Step Numbers

Consider the number $45656$.
It can be seen that each pair of consecutive digits of $45656$ has a difference of one.
A number for which every pair of consecutive digits has a difference of one is called a step number.
A pandigital number contains every decimal digit from $0$ to $9$ at least once.

How many pandigital step numbers less than $10^{40}$ are there?

To solve this problem, we need to consider the systematic construction of such numbers and find a way to count them. For any step number, each digit can either increase or decrease by 1 compared to previous digit, but we have exceptions for 0 and 9, where we only have 1 option (increase or decrease respectively).

We can use dynamic programming to generate the number of step numbers of each length by iteratively building up from smaller to larger numbers. The process can be summarized as below:

First of all, we need to consider the possible number of steps for every digit. To do that, let’s denote `steps[i][j]` be the number of j-digit step numbers that end with i.

Then we initialize the one-digit numbers:
“`
Steps[i][1] = 1 for every i from 0 to 9.
“`

From there, we can generate two-digit step numbers:
“`
Steps[i][2] = Steps[i-1][1] + Steps[i+1][1] for every i from 1 to 8.
Steps[0][2] = Steps[0+1][1]
Steps[9][2] = Steps[9-1][1]
“`

Then continue this pattern to generate three-digit step numbers, four-digit step numbers, and so on, until we get to the 39-digit numbers:
“`
Steps[i][n] = Steps[i-1][n-1] + Steps[i+1][n-1] for every i from 1 to 8 and n from 3 to 39.
Steps[0][n] = Steps[0+1][n-1]
Steps[9][n] = Steps[9-1][n-1]
“`
Simultaneously, to count the number of pandigitals, let’s denote pd[i][j][mask] be the number of j digit pandigital numbers ended with i, where mask is a bitmap to track whether a digit has been used previously (1 if used). We need to apply the information from the Steps matrix into pd.

We have pd[i][j][mask] = pd[i-1][j-1][mask without i] + pd[i+1][j-1][mask without i] for every i from 1 to 8, n from 3 to 39 and mask as a combination of used and unused digits.

Our aim is to find sum of pd[i][39][1023] where i varies from 0 to 9 because 1023 in binary (1111111111) means all digits are used up, and we need combinations of pandigitals for 39 digit numbers.

The remaining digit (to reach 40 digits) can be placed in 39 * 2 ways (at the start or end for 39 podocentrics). To avoid counting over, one must take into account the adjustments needed when the remaining digit is same as the beginning or the end digit.

Please note that the complexity of the above algorithm is linear since you can precalculate 2^10 and the same set can be used iteratively in the dynamic programming approach.

We must also note the computational intensity of this problem. The problem requires a very large number of operations and is not feasible to solve by simply writing a program without performing a thoughtful optimization. Dynamic Programming greatly reduces the time complexity here but even then, we need a powerful processor to calculate this number, especially given the large exponent.

This problem is a classic example of combinatorics and dynamic programming used together.

More Answers:
Fractions and Sum of Powers of Two
Common Cathetus Right-angled Triangles
Integer Angled Quadrilaterals

Error 403 The request cannot be completed because you have exceeded your quota. : quotaExceeded

Share:

Recent Posts

Don't Miss Out! Sign Up Now!

Sign up now to get started for free!